/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XMsgSocket.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Ingo Griebsch
//
// Erstelldatum:	08.01.2001
// letzte nderung:	08.01.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000 by x-treme
/////////////////////////////////////////////////////////////////////////////////////


#define WIN32_LEAN_AND_MEAN		// Selten genutzte Teile aus Win-Header ausschliessen

#ifndef _XMSGSOCKET_H
#define _XMSGSOCKET_H


// Standard-Includes
#include <winsock2.h>
#include <stdlib.h>


// XGame-Includes
#include "XSocket.h"
#include "XLogging.h"


// Klassen-Deklaration
class XMsgSocket : public XSocket
{
	public:
		// Konstruktor		
		XMsgSocket();

		// Destruktor
		virtual ~XMsgSocket();

		// setzt Benachrichtigungs Status des Socket 
		HRESULT select(HWND hWnd, unsigned int uiMessage, long lEvent);

		// setzt Benachrichtigungs Status des Socket zurueck
		HRESULT selectCancel(HWND hWnd);

		// prueft die eingehende Nachricht und gibt, falls Nachricht Socket-Nachricht
		// und Socket der verwendete ist Ereignis und ggfs. Fehler zurueck
		HRESULT socketProc(WORD &dwEvent, 
							WORD &dwError, 
							UINT message, 
							WPARAM wParam, 
							LPARAM lParam);

		/*	
			hier folgen asyncrone sogenannte DB-Funktionen, die von der Windows Socket API 
			zur Verfuegung gestellt werden und sind als statische Methoden realisiert.
		*/
		
		// ### muss ueberarbeitet werden - bisher copy & paste aus XSocket
		static HRESULT getHostByAddress(HANDLE handle, HOSTENT *&hostent, int nHostentLength, LPSTR lpAddress, int nAddressLength, int nAddressType, HWND hWnd, UINT uiMessage);

		static HRESULT getHostByName(void);

		static HRESULT getHostName(void);

	protected:

	private:

};


#endif


class XMsgSocket;


/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XMsgSocket.h
/////////////////////////////////////////////////////////////////////////////////////


